function [E] = check4Equivalences(data)

%    Copyright (C) 2015  Davide Modolo
%
%    You can redistribute and/or modify this software for non-commercial use
%    under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
%    For commercial use, contact the author for licensing options.
%
%    Contact: d.modolo@sms.ed.ac.uk

E = cell(data.nPosW, 1);

for i = 1:data.nPosW
  
    for j = 1:data.nExemplar
                
       % X = find other eesvms with same # of false positives than i
       % every time we only check against "exemplars(i+1:end)"
       % we only want the fill only the top triangular matrix
       
       fp_E  = data.false_pos_count(i, j);
       
       if ~fp_E == 0
           fp_othersE = find(data.false_pos_count(i, j+1:end) == fp_E);
           fp_othersE = fp_othersE + j;

           if ~isempty(fp_othersE)
               % Threshold index of exemplar 'j'
               T_E = data.t4p(i, j);
               negs_E = data.i_sn(1:data.fp_thresh(T_E, j), j);

               for k = 1:length(fp_othersE)

                   T_E_k = data.t4p(i, fp_othersE(k));
                   negs_E_k = ...
                       data.i_sn(1:data.fp_thresh(T_E_k, ...
                       fp_othersE(k)), fp_othersE(k));

                   if sum(negs_E == negs_E_k) == fp_E
                       E{i} = [E{i}; [j, fp_othersE(k)]];
                   end
               end
           end 
       end
    end
    
end

% Count the number of found equivalences
count = 0;
for i = 1:data.nPosW
    count = count + size(E{i}, 1);
end
fprintf('%d found\n', count);