function t4p = getTightestThreshold_PerPositive(all_thresholds, scores)

%    Copyright (C) 2015  Davide Modolo
%
%    You can redistribute and/or modify this software for non-commercial use
%    under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
%    For commercial use, contact the author for licensing options.
%
%    Contact: d.modolo@sms.ed.ac.uk

% OUTPUT:
%   t4p: matrix (P x E), where P = #positive windows
%                              E = #exemplars
%      each cell (p, e) of t4p tells us what is the tightest thresholds for
%      'e' so that 'p' is scored positive. 

% compute pointer to last neg > threshold
t4p = zeros(size(scores));

% Loop over the scores
for i = 1:size(t4p, 1)

    % Loop over the exemplars
    for j = 1:size(t4p, 2)

        x = find(all_thresholds(:, j) <= scores(i, j)+.00001);
        t4p(i, j) = x(1);

    end 

end 